class BlasterMatch(object):

    def __init__(self, bestMatchName = "", coverage = 0.0, strand = "+", identity = 0.0):
        self._matchName = bestMatchName
        self._coverage = round(coverage, 2)
        self._strand = strand
        self._identity = identity

    def __eq__(self, o):
        if o == None:
            return False
        return o._matchName == self._matchName and o._coverage == self._coverage \
            and self._strand == o._strand and self._identity == o._identity
            
    def __str__(self):
        return "%s: %.2f%%" % (self._matchName, self._coverage) 
    
    def isEmpty(self):
        return self._matchName == ""
    
    def getMatchName(self):
        return self._matchName
    
    def getCoverage(self):
        return float(self._coverage)
    
    # For BLRtx_x_Agents
    def getStrand(self):
        return self._strand
    
    # For HG_BLRn_Agent
    def getIdentity(self):
        return float(self._identity)