from PASTEC.utils.AbstractAnalyseAgent import AbstractAnalyseAgent
from PASTEC.DemandAndResult import DemandAndResult
from PASTEC.Size import Size
from PASTEC.ComputeTEConsensusFullSizeResult import ComputeTEConsensusFullSizeResult
import exceptions

## This agent compute the full size of TE consensus 
# 
class FullSize_Agent(AbstractAnalyseAgent):
    
    SUFFIX_TABLE_NAME_LIST = ["_seq"]
    
    ## Get useful informations in database
    #
    # @param consensusName string name of consensus
    #
    def getListOfFeaturesToAnalyse(self, consensusName):
        sql_cmd = 'select length from %s where accession="%s";' % (self._tableName, consensusName)
        self._db.execute(sql_cmd)
        subjectLengthList = self._db.fetchall()
        if subjectLengthList == ():
            raise exceptions("No length found for " + consensusName + " in " +  self._tableName + "!")
        return subjectLengthList
    
    ## Analyse a Demand
    #
    # @param demand a Demand object type (name of Agent and name of sequence to analyse for example)
    # @return result DemandAndResult instance
    #
    def analyse(self, demand, lOfSize):
        size =  self._computeConsensusSize(lOfSize)
        result = DemandAndResult(demand, Size(size))
        return result
    
    def patch(self, iDemandAndResult):
        size = iDemandAndResult.result.getSize()
        return ComputeTEConsensusFullSizeResult(iDemandAndResult.demand, size)
    
    def _computeConsensusSize(self, lOfLength):
        subjectLength = lOfLength[0][0]
        return subjectLength