from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent

class Helitron_Agent(AbstractClassifierAgent):

    CI_MAX = 10 #we consider helitron extremities
    INIT_CLASSIF = "!Helitron"
    SINGLE_CONDITIONS = ('RPA', 'HEL')
    PATTERN_2_SEARCH_IN_BLAST_RESULTS = ":Helitron"
    PROFILES_2_SEARCH_IN_ORF = ('RPA', 'HEL')
    INCREASED_CI_CONDITIONS = ['>4000bps']
    DECREASED_CI_CONDITIONS = ['<700bps']
    CATEGORY_LENGTH_BOUND = [700, 4000, 10000]
    
    def __init__(self, env):
        AbstractClassifierAgent.__init__(self, env)
        self._listOfKnownAgents.extend(["TE_BLRn_Agent"])
    
    def getAgentName(self):
        return "Helitron"
    
    def makeAppropriateConclusionsForTE_BLRn_Agent(self, iDemandAndResult):
        if iDemandAndResult != None and iDemandAndResult.result!=[]:
            self._conclusionsMatch.append({'helitronExtremities': iDemandAndResult.result})
                                
    def _considerHelitronExtremities(self, conclusion, classification):
        if conclusion['helitronExtremities'] != []:            
            classification = self.getAgentName()
            if len(conclusion['helitronExtremities']) == 2:
                self._CI += 2
            else:
                self._CI += 1
        return classification

    def _decideForConclusionsMatch(self, classification):
        lType = []
        for conclusion in self._conclusionsMatch:
            if conclusion.has_key('Repbase_tbx') or conclusion.has_key('Repbase_bx'):
                classification = self._considerBlastxAndTBlastxEvidence(conclusion, classification)
            elif conclusion.has_key('helitronExtremities'):
                classification = self._considerHelitronExtremities(conclusion, classification)
            elif conclusion.has_key("ORF"):
                self._considerProfilesInSameFrameAsORF(conclusion)
            else:
                classification, lType = self._considerProfilesIfTheyAreDiscriminant(conclusion, classification, lType)
        return classification