from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent

class LARD_Agent(AbstractClassifierAgent):
    
    CI_MAX = 5
    INIT_CLASSIF = "!LARD"
#    COMPLEXE_CONDITIONS = [('termLTR', '>4000bps', '!orf')]
    COMPLEXE_CONDITIONS = [('termLTR', '>1000bps')]
    PATTERN_2_SEARCH_IN_BLAST_RESULTS = ":LARD"
    DECREASED_CI_CONDITIONS = [">10000bps"] # and !orf
    CATEGORY_LENGTH_BOUND = [1000, 10000]
    
    def __init__(self, env):
        self._environment = env
        self._dAgentName2AnalyserInstance = {}
        self._listOfKnownAgents = ["Size_Agent", "TRSearch_Agent", "TE_BLRx_Agent", "TE_BLRtx_Agent", "ORF_Agent"]
        self._CI = 0

    def getAgentName(self):
        return "LARD"
    
    def makeAppropriateConclusionsForTRSearch_Agent(self, iDemandAndResult):
        if iDemandAndResult != None:
            for iResult in iDemandAndResult.result:
                if "termLTR" == iResult.getType():
                    self._conclusionsSearch.append(iResult)

    #TODO: how to handle "!orf" ?
    def _decideForComplexConditions(self, classification):
        for conclusion in self._conclusionsMatch:
            if conclusion.has_key('ORF'):
                return classification
        for tuple in self.COMPLEXE_CONDITIONS:
            classification = self.considerMultipleConclusionIfTheyAreDiscriminant(tuple, classification)
        return classification