from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent
import re

class LINE_Agent(AbstractClassifierAgent):

    #TODO: condition to exclude SSR (i.e. : dict: {'length': '>700bps', 'SSRtrf': ['(AT)200_start', '(AT)300_end']} )
    CI_MAX = 11 #consider 2 single conditions (weight=2), 1 complex condition, 2 BLR, 4 profiles in ORF
    INIT_CLASSIF = "!LINE"
    SINGLE_CONDITIONS = ('EN', 'APE')
    COMPLEXE_CONDITIONS = [('>700bps', 'polyAtail'), ('>700bps', '\(A\)\d+_end'), ('>700bps', '\(AT\)\d+_end'), \
                           ('>700bps', '\(T\)\d+_start'), ('>700bps', '\(TA\)\d+_start'), ('>700bps', '\(TAA\)\d+_end'), \
                           ('>700bps', '\(ATT\)\d+_start')]
    PATTERN_2_SEARCH_IN_BLAST_RESULTS = ":LINE"
    NOPATTERN_2_SEARCH_IN_BLAST_RESULTS = "(Penelope|PENELOPE)"
    PROFILES_2_SEARCH_IN_ORF = ('RT', 'EN', 'APE', 'RH')
    DECREASED_CI_CONDITIONS = [">10000bps"]
    CATEGORY_LENGTH_BOUND = [700, 10000]

    def __init__(self, env):
        AbstractClassifierAgent.__init__(self, env)
        self._listOfKnownAgents.extend(["PolyA_Agent", "SSRtrf_Agent"])
    
    def getAgentName(self):
        return "LINE"
    
    def makeAppropriateConclusionsForPolyA_Agent(self, iDemandAndResult):
        if iDemandAndResult != None and iDemandAndResult.result != None:
            iPolyATail = iDemandAndResult.result
            if iPolyATail.isTailPresent():
                self._conclusionsSearch.append(iPolyATail.__str__())
                
    def makeAppropriateConclusionsForSSRtrf_Agent(self, iDemandAndResult):
        if iDemandAndResult != None and iDemandAndResult.result != None:
            iSSRCollection = iDemandAndResult.result
            if not iSSRCollection.isEmpty():
                for iSSR in iSSRCollection.getSSRList():
                    self._conclusionsSearch.append(iSSR.__str__())
                    
    ## Get and filter analysis if corresponding table is in database.
    #
    def getAnalysesResults(self):
        for iAgent in self._dAgentName2AnalyserInstance.values():
            iAgentResult = self._callAgent(iAgent)
            method2Call = "self.makeAppropriateConclusionsFor" + str(iAgent.__class__.__name__) + "( iAgentResult )"
            exec ( method2Call )
        for conclusion in self._conclusionsSearch:
            if re.match('\(A\)\d+_end', conclusion) and 'polyAtail' in self._conclusionsSearch:
                self._conclusionsSearch.remove(conclusion)