from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent

class LTR_Agent(AbstractClassifierAgent):
    
    CI_MAX = 14
    INIT_CLASSIF = "!LTR"
    SINGLE_CONDITIONS = ['ENV']
    COMPLEXE_CONDITIONS = [('termLTR', '(INT|GAG|AP|RH)')]
    PATTERN_2_SEARCH_IN_BLAST_RESULTS = ":LTR_retrotransposon|:LTR:"
    NOPATTERN_2_SEARCH_IN_BLAST_RESULTS = "(DIRS|Ngaro|VIPER)"
    PROFILES_2_SEARCH_IN_ORF = ('GAG', 'AP', 'INT', 'RT', 'RH', 'ENV')
    DECREASED_CI_CONDITIONS = [">10000bps"]
    CATEGORY_LENGTH_BOUND = [700, 4000, 10000]

    def getAgentName(self):
        return "LTR"
    
    def makeAppropriateConclusionsForTRSearch_Agent(self, iDemandAndResult):
        if iDemandAndResult != None:
            for iResult in iDemandAndResult.result:
                if "termLTR" == iResult.getType():
                    self._conclusionsSearch.append(iResult)