from pyRepetUnit.commons.sql.TableSetAdaptator import TableSetAdaptator 
from PASTEC.DemandAndResult import DemandAndResult
from PASTEC.PolyATail import PolyATail
from PASTEC.utils.AbstractAnalyseAgent import AbstractAnalyseAgent
import re

## This agent search in the database if the consensus has a polyA tail 
#
class PolyA_Agent(AbstractAnalyseAgent):

    SUFFIX_TABLE_NAME_LIST = ["_polyA_set"]
    
    def analyse(self, demand, lSet):
        iPolyATail = PolyATail()
        for polyA_result in lSet:
            if re.match("termPoly.*", polyA_result.name):
                iPolyATail.setIsTailPresent(True)
                break
        return DemandAndResult(demand, iPolyATail)   
        
    def getListOfFeaturesToAnalyse(self, consensusName):
        polyA_set = TableSetAdaptator(self._db, self._tableName)
        lSet = polyA_set.getSetListFromSeqName(consensusName)
        return lSet